#include "mcc_generated_files/mcc.h"

#define TIME_OFF -1         //^C}[gpȂꍇ
#define TIME_UP 0           //^CAbv
#define LED_WAIT 20
#define DI_MAX 2
#define DI_FILT_MAX 4            //DItB^̃TvO
#define TIME_FILTER_MAX 1    //x[X^C}JEgl
#define	CNT_INIT_MAX 10     //10ms~10 = 100ms
#define STEP_OFF 100
#define STEP_START_FREQ 10000
#define STEP_CUT 1000

typedef struct{
    uint8_t wp;
    uint8_t buf[DI_MAX][DI_FILT_MAX];
    uint8_t di[DI_MAX];
}DIFILT_TYP;

int16_t timStep;
int16_t timled1 = TIME_OFF;
int16_t timled2 = TIME_OFF;
int16_t timstepoff = TIME_OFF;
DIFILT_TYP difilt;
int16_t timdifilt;   //DItB^N
uint8_t CntInit;	//̂ݎgp
uint16_t stepfreq_n;
uint16_t stepfreq_p;

void mainTimer(void);
void mainApp(void);
void StepMove(uint8_t no, uint16_t wait );
void DiFilter(void);

/* Main application */
void main(void)
{
    // initialize the device
    SYSTEM_Initialize();
    TMR0_SetInterruptHandler(mainTimer);
    INTERRUPT_GlobalInterruptEnable();
    INTERRUPT_PeripheralInterruptEnable();
    
	CntInit = CNT_INIT_MAX;
	while(CntInit > 0){  //0ɂȂ܂ŃtB^{
        DiFilter();         //DItB^
        __delay_ms(10);     //10msxDItB^
        CntInit--;
        timdifilt = TIME_UP;
	}      

    while (1)
    {
        mainApp();
        DiFilter();
    }
}

/* ^C}Ǘ֐ */
void mainTimer(void){
 
    if( timled1 > TIME_UP ){
        --timled1;
    }
    
    if( timled2 > TIME_UP ){
        --timled2;
    }    

    if( timdifilt > TIME_UP ){
        --timdifilt;
    }
    
    if( timstepoff > TIME_UP ){
        --timstepoff;
    }
   
}
/* C */
void mainApp(void){
    uint8_t i,j;
    
    if( timled1 == TIME_UP ){
        timled1 = TIME_OFF;
        IO_RB7_Toggle();
    }
    
    if( timled2 == TIME_UP ){
        timled2 = TIME_OFF;
        IO_RB6_Toggle();
    }
    
    if( timstepoff == TIME_UP){
        timstepoff = TIME_OFF;
        IO_RB3_SetLow();
        IO_RB2_SetLow();
        IO_RB1_SetLow();
        IO_RB0_SetLow(); 
    }
    
    if(difilt.di[0] == LOW ){
        if(timled1 == TIME_OFF){
            timled1 = LED_WAIT;
        }
        timstepoff = STEP_OFF;
                
        for(i=0; i < 8; i++){
            StepMove(i, stepfreq_n );
        }

        if(stepfreq_n <= STEP_CUT){
            stepfreq_n = STEP_CUT;
        }
        else{
            stepfreq_n -= STEP_CUT;
        }
    }
    else{
        stepfreq_n = STEP_START_FREQ;
        IO_RB7_SetLow();
    }

    if(difilt.di[1] == LOW ){
        if( timled2 == TIME_OFF){
            timled2 = LED_WAIT;
        }
        timstepoff = STEP_OFF;
        
        for(i=0; i < 8; i++){
            StepMove(7-i, stepfreq_p);
        }
        
        if(stepfreq_p <= STEP_CUT){
            stepfreq_p = STEP_CUT;
        }
        else{
            stepfreq_p -= STEP_CUT;
        }
        
    }
    else{
        stepfreq_p = STEP_START_FREQ;
        IO_RB6_SetLow();
    }
}


void StepMove(uint8_t no, uint16_t wait ){

    switch(no){
        case 0: //Xebv1 0111
            IO_RB3_SetLow();
            IO_RB2_SetHigh();
            IO_RB1_SetHigh();
            IO_RB0_SetHigh();
            break;
        case 1: //Xebv2 0011
            IO_RB3_SetLow();
            IO_RB2_SetLow();
            IO_RB1_SetHigh();
            IO_RB0_SetHigh();
            break;    
        case 2: //Xebv3 1011
            IO_RB3_SetHigh();
            IO_RB2_SetLow();
            IO_RB1_SetHigh();
            IO_RB0_SetHigh();
            break;              
        case 3: //Xebv4 1001
            IO_RB3_SetHigh();
            IO_RB2_SetLow();
            IO_RB1_SetLow();
            IO_RB0_SetHigh();
            break;
        case 4: //Xebv5 1101
            IO_RB3_SetHigh();
            IO_RB2_SetHigh();
            IO_RB1_SetLow();
            IO_RB0_SetHigh();
            break;            
        case 5: //Xebv6 1100
            IO_RB3_SetHigh();
            IO_RB2_SetHigh();
            IO_RB1_SetLow();
            IO_RB0_SetLow();
            break;            
        case 6: //Xebv7 1110
            IO_RB3_SetHigh();
            IO_RB2_SetHigh();
            IO_RB1_SetHigh();
            IO_RB0_SetLow();
            break;
        case 7: //Xebv8 0110
            IO_RB3_SetLow();
            IO_RB2_SetHigh();
            IO_RB1_SetHigh();
            IO_RB0_SetLow();
            break;                 
    }
    DELAY_microseconds(wait); //]x𒲐
}
/* DiFilter function add */
void DiFilter(void){
    uint8_t i;

    if( timdifilt == TIME_UP ){
        timdifilt = TIME_FILTER_MAX;
        difilt.buf[0][difilt.wp] = IO_RB4_GetValue();
        difilt.buf[1][difilt.wp] = IO_RB5_GetValue();

        for(i=0; i < DI_MAX; i++){
            if( difilt.buf[i][0] == difilt.buf[i][1] &&
            difilt.buf[i][1] == difilt.buf[i][2] &&
            difilt.buf[i][2] == difilt.buf[i][3] ){ //4vmF
            difilt.di[i] = difilt.buf[i][0];
            }
        }

        if( ++difilt.wp >= DI_FILT_MAX ){
          difilt.wp = 0;
        }
    }
}
/* End of File */